unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Mask, Buttons, Spin, ExtCtrls, TabNotBk,
  MDate;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    TabbedNotebook1: TTabbedNotebook;
    chbEnableDOW: TCheckBox;
    Label2: TLabel;
    rdgDOW: TRadioGroup;
    rdgDateFormat: TRadioGroup;
    GroupBox1: TGroupBox;
    Button2: TBitBtn;
    Button1: TBitBtn;
    Button3: TBitBtn;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edtDOW: TEdit;
    edtDay: TEdit;
    edtMth: TEdit;
    edtYr: TEdit;
    memProcedures: TMemo;
    memFunctions: TMemo;
    memConstants: TMemo;
    Label7: TLabel;
    Label8: TLabel;
    edtDOY: TEdit;
    edtWOY: TEdit;
    rdgLang: TRadioGroup;
    lbxStartOfWeek: TListBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    DateControl: TMDateControl;
    procedure Button2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure rdgDateFormatClick(Sender: TObject);
    procedure chbEnableDOWClick(Sender: TObject);
    procedure rdgDOWClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure DateControlChange(Sender: TObject);
    procedure lbxStartOfWeekClick(Sender: TObject);
    procedure rdgLangClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetDateParams;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
{set control's date to Jan 01, 2000}
var
  Yr, Mth, Day: Word;
  d: TDateTime;
begin
  {the long way}
  Yr:=2000;
  Mth:=1;
  Day:=1;
  {create the TDateTime variable with the specified date parameters}
  d:=EncodeDate(Yr, Mth, Day);
  {set DateControl's date to the first day of the next millenium}
  DateControl.SetDate(d);

  {another way: in one statement, no variables needed...}
  DateControl.SetDate(EncodeDate(2000, 1, 1));
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  {set DateControl's date first}
  DateControl.SetDate(now);
  {set form controls...}
  {date format radioGroup}
  rdgDateFormat.itemindex:=Integer(DateControl.DateFormat);
  {StartOfWeek selection listbox}
  lbxStartOfWeek.items.assign(DateControl.GetDOWs);
  lbxStartOfWeek.itemindex:=Integer(DateControl.StartOfWeek);
  {select current language (English is default)}
  rdgLang.itemindex:=Integer(DateControl.Language);
  {DayOfWeek selection feature}
  DateControl.EnableDOW:=chbEnableDOW.checked;
  rdgDOW.enabled:=chbEnableDOW.checked;
end;

procedure TForm1.rdgDateFormatClick(Sender: TObject);
begin
  DateControl.SetDateFormat(TMDateFormat(rdgDateFormat.itemIndex));
end;

procedure TForm1.chbEnableDOWClick(Sender: TObject);
begin
  {enable/disable the DayOfWeek selection for the DateControl's calendar}
  DateControl.EnableDOW:=chbEnableDOW.checked;
  rdgDOW.enabled:=chbEnableDOW.checked;
end;

procedure TForm1.rdgDOWClick(Sender: TObject);
begin
  {if DayOfWeek selection is enabled - enable the selected day of the week}
  if DateControl.EnableDOW then
    DateControl.setEnabledDOW(rdgDOW.itemindex);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  DateControl.SetDate(now+1);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  {if valid date}
  if DateControl.GetDate > 0 then
    showmessage('The DateControl'#39's date is: '+
      formatDateTime('dddd, mmmm dd, yyyy.', DateControl.GetDate))
  else
    showmessage('The DateControl'#39's date has not been set!'#13+
      'Use the ... button to display calendar.');
end;

procedure TForm1.DateControlChange(Sender: TObject);
begin
  SetDateParams;
end;

procedure TForm1.SetDateParams;
begin
  if DateControl.GetDate > 0 then
  with DateControl do begin
    edtDOW.text:=DateControl.GetDayOfWeek;
    edtDay.text:=intToStr(DateControl.GetDay);
    edtMth.text:=DateControl.GetMonthOfYear;
    edtYr.text:=intToStr(DateControl.GetYr);
    edtDOY.text:=intToStr(DateControl.GetDOY);
    edtWOY.text:=intToStr(DateControl.GetWOY);
    {StartOfWeek selection listbox}
    lbxStartOfWeek.items.assign(GetDOWs);
    lbxStartOfWeek.itemindex:=Integer(StartOfWeek);
    {load Enabled DayOfWeek}
    rdgDOW.items.assign(GetDOWs);
    rdgDOW.itemindex:=Integer(EnabledDOW);
  end;
end;

procedure TForm1.lbxStartOfWeekClick(Sender: TObject);
begin
  DateControl.SetStartOfWeek(lbxStartOfWeek.itemindex);
  SetDateParams;
end;

procedure TForm1.rdgLangClick(Sender: TObject);
begin
  DateControl.SetLanguage(TMLanguage(rdgLang.itemindex));
  SetDateParams;
end;

end.
